      SUBROUTINE BLKTR1 (N,AN,BN,CN,M,AM,BM,CM,IDIMY,Y,B,W1,W2,W3,WD,   POI03659
     1                   WW,WU,PRDCT,CPRDCT)
C
C BLKTR1 SOLVES THE LINEAR SYSTEM
C
C B  CONTAINS THE ROOTS OF ALL THE B POLYNOMIALS
C W1,W2,W3,WD,WW,WU  ARE ALL WORKING ARRAYS
C PRDCT  IS EITHER PRODP OR PROD DEPENDING ON WHETHER THE BOUNDARY
C CONDITIONS IN THE M DIRECTION ARE PERIODIC OR NOT
C CPRDCT IS EITHER CPRODP OR CPROD WHICH ARE THE COMPLEX VERSIONS
C OF PRODP AND PROD. THESE ARE CALLED IN THE EVENT THAT SOME
C OF THE ROOTS OF THE B SUB P POLYNOMIAL ARE COMPLEX
C
C
      DIMENSION       AN(1)      ,BN(1)      ,CN(1)      ,AM(1)      ,
     1                BM(1)      ,CM(1)      ,B(1)       ,W1(1)      ,
     2                W2(1)      ,W3(1)      ,WD(1)      ,WW(1)      ,
     3                WU(1)      ,Y(IDIMY,1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NCMPLX     ,IK         ,IZ
      NH = 2**K
      IH1 = NH+NH
C
C BEGIN REDUCTION PHASE
C
      KDO = K
      IF (NPP) 101,102,101
  101 KDO = K-1
  102 DO 108 L=1,KDO
         IR = L-1
         IZ = 2**IR
         ISGN = (-1)**IR
         MSGN = -ISGN
         IH2 = 2**(K-IR+1)
         LM = (IR-2)*IH1+IH2+IH2+1
         LZ = (IR-1)*IH1+IH2+1
         IIM = IZ-1
         IIZ = IIM+IIM+1
         JM1 = IIM+IIM+LM
         I1 = IZ+IZ
         CALL PRDCT (IIZ,B(LZ),IIM,B(LM),IIM,B(JM1),0,DUM,Y(1,IZ),W3,M,
     1               AM,BM,CM,WD,WW,WU,ISGN)
         IF = 2**(K-IR-1)
         DO 107 JJ=1,IF
            I = JJ*I1
            I6 = I
            I7 = I-IZ
            I9 = I+IZ
            J2 = JJ+JJ
            J4 = J2+J2
            JM1 = (J4-2)*IIM+LM
            JP1 = J4*IIM+LM
            JP2 = J2*IIZ+LZ
            JP3 = (J4+2)*IIM+LM
            IF (JJ-IF) 105,103,103
  103       IF (NPP) 107,104,107
  104       JP1 = LM
            JP2 = LZ
            JP3 = IIM+IIM+LM
            I6 = 0
            I9 = IZ
  105       CALL PRDCT (IIM,B(JM1),0,DUM,0,DUM,IZ,AN(I7+1),W3,W1,M,AM,
     1                  BM,CM,WD,WW,WU,MSGN)
            CALL PRDCT (IIZ,B(JP2),IIM,B(JP1),IIM,B(JP3),0,DUM,Y(1,I9),
     1                  W3,M,AM,BM,CM,WD,WW,WU,ISGN)
            CALL PRDCT (IIM,B(JP1),0,DUM,0,DUM,IZ,CN(I6+1),W3,W2,M,AM,
     1                  BM,CM,WD,WW,WU,MSGN)
            DO 106 J=1,M
               Y(J,I) = W1(J)+W2(J)-Y(J,I)
  106       CONTINUE
  107    CONTINUE
  108 CONTINUE
      IF (NPP) 112,109,112
  109 J2 = 2*N*(K-1)+3
      J1 = 2*N*(K-2)+5
      IF (NCMPLX) 110,111,110
  110 CALL CPRDCT (N,B(J2),N-1,B(J1),0,DUM,0,DUM,Y(1,N),Y(1,N),M,AM,BM,
     1             CM,W1,W3,WW,MSGN)
      GO TO 112
  111 CALL PRDCT (N,B(J2),N-1,B(J1),0,DUM,0,DUM,Y(1,N),Y(1,N),M,AM,BM,
     1            CM,WD,WW,WU,MSGN)
C
C BEGIN BACK SUBSTITUTION PHASE
C
  112 DO 126 LL=1,K
         L = K-LL+1
         IR = L-1
         ISGN = (-1)**IR
         MSGN = -ISGN
         IZ = 2**IR
         IIM = IZ-1
         IIZ = IIM+IIM+1
         IH2 = 2**(K-IR+1)
         LM = (IR-2)*IH1+IH2+IH2+1
         LZ = (IR-1)*IH1+IH2+1
         IF = 2**(K-IR)-1
         DO 125 JJ=1,IF,2
            I = JJ*IZ
            I5 = I-IZ
            I6 = I+IZ
            I7 = I5
            J2 = JJ+JJ
            JM1 = (J2-2)*IIM+LM
            JZ = (JJ-1)*IIZ+LZ
            JP1 = J2*IIM+LM
            IF (JJ-1) 113,113,117
  113       IF (NPP) 115,114,115
  114       I7 = N
            GO TO 117
  115       DO 116 J=1,M
               W1(J) = 0.
  116       CONTINUE
            GO TO 118
  117       CALL PRDCT (IIM,B(JM1),0,DUM,0,DUM,IZ,AN(I5+1),Y(1,I7),W1,
     1                  M,AM,BM,CM,WD,WW,WU,MSGN)
  118       IF (JJ-IF) 122,119,119
  119       IF (NPP) 120,122,120
  120       DO 121 J=1,M
               W2(J) = 0.
  121       CONTINUE
            GO TO 123
  122       CALL PRDCT (IIM,B(JP1),0,DUM,0,DUM,IZ,CN(I+1),Y(1,I6),W2,M,
     1                  AM,BM,CM,WD,WW,WU,MSGN)
  123       DO 124 J=1,M
               W1(J) = Y(J,I)-W1(J)-W2(J)
  124       CONTINUE
            CALL PRDCT (IIZ,B(JZ),IIM,B(JM1),IIM,B(JP1),0,DUM,W1,
     1                  Y(1,I),M,AM,BM,CM,WD,WW,WU,ISGN)
  125    CONTINUE
  126 CONTINUE
      RETURN
      END
