C     PROGRAM XAMPLE                                                    POI05019
C                                                                       POI05020
C***********************************************************************POI05021
C                                                                       POI05022
C          VERSION  2  OCTOBER 1976  INCLUDING ERRATA  OCTOBER 1976     POI05023
C                                                                       POI05024
C         DOCUMENTATION FOR THIS PROGRAM IS GIVEN IN                    POI05025
C                                                                       POI05026
C        EFFICIENT FORTRAN SUBPROGRAMS FOR THE SOLUTION OF              POI05027
C            ELLIPTIC PARTIAL DIFFERENTIAL EQUATIONS                    POI05028
C                                                                       POI05029
C                              BY                                       POI05030
C                                                                       POI05031
C          PAUL SWARZTRAUBER   AND  ROLAND SWEET                        POI05032
C                                                                       POI05033
C             TECHNICAL NOTE TN/IA-109   JULY 1975                      POI05034
C                                                                       POI05035
C       NATIONAL CENTER FOR ATMOSPHERIC RESEARCH  BOULDER,COLORADO 80307POI05036
C                                                                       POI05037
C        WHICH IS SPONSORED BY THE NATIONAL SCIENCE FOUNDATION          POI05038
C                                                                       POI05039
C***********************************************************************POI05040
C                                                                       POI05041
C                                                                       POI05042
C     PROGRAM TO ILLUSTRATE THE USE OF PWSSSP                           POI05043
C                                                                       POI05044
      DIMENSION       F(19,73)   ,BDTF(73)   ,SINT(19)   ,SINP(73)   ,  POI05045
     1                W(647)                                            POI05046
C                                                                       POI05047
C     THE VALUE OF IDIMF IS THE FIRST DIMENSION OF F. W IS DIMENSIONED  POI05048
C     11*(M+1)+6X(N+1)=647 SINCE M=18 AND N=72                          POI05049
C                                                                       POI05050
      PI = 3.141592653589793                                            POI05051
      INTL = 0                                                          POI05052
      TS = 0                                                            POI05053
      TF = PI/2.                                                        POI05054
      M = 18                                                            POI05055
      MBDCND = 6                                                        POI05056
      PS = 0                                                            POI05057
      PF = PI+PI                                                        POI05058
      N = 72                                                            POI05059
      NBDCND = 0                                                        POI05060
      ELMBDA = 0.                                                       POI05061
      IDIMF = 19                                                        POI05062
C                                                                       POI05063
C     GENERATE SINES FOR USE IN SUBSEQUENT COMPUTATIONS                 POI05064
C                                                                       POI05065
      DTHETA = TF/FLOAT(M)                                              POI05066
      MP1 = M+1                                                         POI05067
      DO 101 I=1,MP1                                                    POI05068
         SINT(I) = SIN(FLOAT(I-1)*DTHETA)                               POI05069
  101 CONTINUE                                                          POI05070
      DPHI = (PI+PI)/FLOAT(N)                                           POI05071
      NP1 = N+1                                                         POI05072
      DO 102 J=1,NP1                                                    POI05073
         SINP(J) = SIN(FLOAT(J-1)*DPHI)                                 POI05074
  102 CONTINUE                                                          POI05075
C                                                                       POI05076
C     COMPUTE RIGHT SIDE OF EQUATION AND STORE IN F                     POI05077
C                                                                       POI05078
      DO 104 J=1,NP1                                                    POI05079
         DO 103 I=1,MP1                                                 POI05080
            F(I,J) = 2.-6.*(SINT(I)*SINP(J))**2                         POI05081
  103    CONTINUE                                                       POI05082
  104 CONTINUE                                                          POI05083
C                                                                       POI05084
C     STORE DERIVATIVE DATA AT THE EQUATOR                              POI05085
C                                                                       POI05086
      DO 105 J=1,NP1                                                    POI05087
         BDTF(J) = 0.                                                   POI05088
  105 CONTINUE                                                          POI05089
C                                                                       POI05090
      CALL PWSSSP (INTL,TS,TF,M,MBDCND,BDTS,BDTF,PS,PF,N,NBDCND,BDPS,   POI05091
     1             BDPF,ELMBDA,F,IDIMF,PERTRB,IERROR,W)                 POI05092
C                                                                       POI05093
C     COMPUTE DISCRETIZATION ERROR. SINCE PROBLEM IS SINGULAR, THE      POI05094
C     SOLUTION MUST BE NORMALIZED.                                      POI05095
C                                                                       POI05096
      ERR = 0                                                           POI05097
      DO 107 J=1,NP1                                                    POI05098
         DO 106 I=1,MP1                                                 POI05099
            Z = ABS(F(I,J)-(SINT(I)*SINP(J))**2-F(1,1))                 POI05100
            IF (Z .GT. ERR) ERR = Z                                     POI05101
  106    CONTINUE                                                       POI05102
  107 CONTINUE                                                          POI05103
C                                                                       POI05104
      PRINT 1001 , IERROR,ERR,PERTRB                                    POI05105
      STOP                                                              POI05106
C                                                                       POI05107
C                                                                       POI05108
C                                                                       POI05109
 1001 FORMAT (///9H IERROR= ,I3,10X,22H DISCRETIZATION ERR = ,E12.4,    POI05110
     1        14H PERTURBATION=,E12.4)                                  POI05111
C                                                                       POI05112
      END                                                               POI05113
