      SUBROUTINE PPADD (N,IERROR,A,C,CBP,BP,BH,BN)                      POI04221
C
C PPADD COMPUTES THE ROOTS OF THE B SUB P POLYNOMIAL
C THIS ROUTINE IS CALLED AT THE LAST STEP OF THE PREPROCESSING PHASE
C IN THE CASE OF PERIODIC BOUNDARY CONDITIONS
C
C N IS THE ORDER OF THE BH AND BP POLYNOMIALS
C BP IS WHERE THE ROOTS OF THE B SUB P POLYNOMIAL ARE STORED
C CBP IS THE SAME AS BP EXCEPT TYPE COMPLEX
C BH IS USED TO TEMPORARILY STORE THE ROOTS OF THE B HAT POLYNOMIAL
C WHICH ENTERS THROUGH BP
C BN IS TEMPORARY STORAGE USED TO INDICATE THE TYPE OF ROOT IN BP
C WHETHER REAL, DOUBLE OR COMPLEX
C
      COMPLEX         CF         ,CX         ,FSG        ,HSG        ,
     1                DD         ,F          ,FP         ,FPP        ,
     2                CDIS       ,R1         ,R2         ,R3         ,
     3                CBP
      DIMENSION       A(1)       ,C(1)       ,BP(1)      ,BH(1)      ,
     1                BN(1)      ,CBP(1)
      COMMON /CBLKT/  NPP        ,K          ,EPS        ,CNV        ,
     1                NCMPLX     ,IK         ,IZ
      EXTERNAL        PSGF       ,PPSPF      ,PPSGF
      SCNV = SQRT(CNV)
      IZ = N
      IZM2 = IZ-2
      DO 101 J=1,IZ
         BH(J) = BP(J)
  101 CONTINUE
      XL = BH(1)
      DB = BH(3)-BH(1)
  102 XL = XL-DB
      IF (PSGF(XL,IZ,C,A,BH)) 102,103,103
  103 SGN = -1.
      CBP(1) = CMPLX(BSRH(XL,BH(1),IZ,C,A,BH,PSGF,SGN),0.)
      XR = BH(IZ)
      DB = BH(IZ)-BH(IZ-2)
  104 XR = XR+DB
      IF (PSGF(XR,IZ,C,A,BH)) 104,105,105
  105 SGN = 1.
      CBP(IZ) = CMPLX(BSRH(BH(IZ),XR,IZ,C,A,BH,PSGF,SGN),0.)
      DO 121 IG=2,IZM2,2
         XL = BH(IG)
         XR = BH(IG+1)
         SGN = -1.
         XM = BSRH(XL,XR,IZ,C,A,BH,PPSPF,SGN)
         PSG = PSGF(XM,IZ,C,A,BH)
         IF (PSG-EPS) 107,106,106
C
C     CASE OF A REAL ZERO
C
  106    SGN = 1.
         CBP(IG) = CMPLX(BSRH(BH(IG),XM,IZ,C,A,BH,PSGF,SGN),0.)
         SGN = -1.
         CBP(IG+1) = CMPLX(BSRH(XM,BH(IG+1),IZ,C,A,BH,PSGF,SGN),0.)
         BN(IG) = 0.
         BN(IG+1) = 0.
         GO TO 121
C
C     CASE OF A COMPLEX ZERO
C
  107    IT = 0
         ICV = 0
         CX = CMPLX(XM,0.)
  108    FSG = (1.,0.)
         HSG = (1.,0.)
         FP = (0.,0.)
         FPP = (0.,0.)
         DO 109 J=1,IZ
            DD = 1./(CX-BH(J))
            FSG = FSG*A(J)*DD
            HSG = HSG*C(J)*DD
            FP = FP+DD
            FPP = FPP-DD*DD
  109    CONTINUE
         F = (1.,0.)-FSG-HSG
         I3 = 0
         IF (CABS(FP)) 111,111,110
  110    I3 = 1
         R3 = -F/FP
  111    I2 = 0
         IF (CABS(FPP)) 117,117,112
  112    I2 = 1
         CDIS = CSQRT(FP**2-2.*F*FPP)
         R1 = CDIS-FP
         R2 = -FP-CDIS
         IF (CABS(R1)-CABS(R2)) 114,114,113
  113    R1 = R1/FPP
         GO TO 115
  114    R1 = R2/FPP
  115    R2 = 2.*F/FPP/R1
         IF (CABS(R2) .LT. CABS(R1)) R1 = R2
         IF (I3) 118,118,116
  116    IF (CABS(R3) .LT. CABS(R1)) R1 = R3
         GO TO 118
  117    R1 = R3
  118    CX = CX+R1
         IT = IT+1
         IF (IT .GT. 50) GO TO 124
         IF (CABS(R1) .GT. SCNV) GO TO 108
         IF (ICV) 119,119,120
  119    ICV = 1
         GO TO 108
  120    CBP(IG) = CX
         CBP(IG+1) = CONJG(CX)
  121 CONTINUE
      NCMPLX = 1
      DO 122 J=2,IZ
         IF (AIMAG(CBP(J))) 125,122,125
  122 CONTINUE
      NCMPLX = 0
      DO 123 J=2,IZ
         BP(J) = REAL(CBP(J))
  123 CONTINUE
      GO TO 125
  124 IERROR = 4
  125 CONTINUE
      RETURN
      END
