      SUBROUTINE PROD (ND,BD,NM1,BM1,NM2,BM2,NA,AA,X,Y,M,A,B,C,D,W,U,IS)POI03792
C
C PROD APPLIES A SEQUENCE OF MATRIX OPERATIONS TO THE VECTOR X AND
C STORES THE RESULT IN Y
C BD,BM1,BM2 ARE ARRAYS CONTAINING ROOTS OF CERTIAN B POLYNOMIALS
C ND,NM1,NM2 ARE THE LENGTHS OF THE ARRAYS BD,BM1,BM2 RESPECTIVELY
C AA   ARRAY CONTAINING SCALAR MULTIPLIERS OF THE VECTOR X
C NA IS THE LENGTH OF THE ARRAY AA
C X,Y  THE MATRIX OPERATIONS ARE APPLIED TO X AND THE RESULT IS Y
C A,B,C  ARE ARRAYS WHICH CONTAIN THE TRIDIAGONAL MATRIX
C M  IS THE ORDER OF THE MATRIX
C D,W,U ARE WORKING ARRAYS
C IS  DETERMINES WHETHER OR NOT A CHANGE IN SIGN IS MADE
C
      DIMENSION       A(1)       ,B(1)       ,C(1)       ,X(1)       ,
     1                Y(1)       ,D(1)       ,W(1)       ,BD(1)      ,
     2                BM1(1)     ,BM2(1)     ,AA(1)      ,U(1)
      IF (ND) 102,102,101
  101 IF (IS) 104,104,102
  102 DO 103 J=1,M
         W(J) = X(J)
         Y(J) = X(J)
  103 CONTINUE
      GO TO 106
  104 DO 105 J=1,M
         W(J) = -X(J)
         Y(J) = W(J)
  105 CONTINUE
  106 MM = M-1
      ID = ND
      IBR = 0
      M1 = NM1
      M2 = NM2
      IA = NA
  107 IF (IA) 110,110,108
  108 RT = AA(IA)
      IA = IA-1
C
C SCALAR MULTIPLICATION
C
      DO 109 J=1,M
         Y(J) = RT*W(J)
  109 CONTINUE
  110 IF (ID) 130,130,111
  111 RT = BD(ID)
      ID = ID-1
      IF (ID .EQ. 0) IBR = 1
C
C BEGIN SOLUTION TO SYSTEM
C
      D(M) = A(M)/(B(M)-RT)
      W(M) = Y(M)/(B(M)-RT)
      DO 112 J=2,MM
         K = M-J
         DEN = B(K+1)-RT-C(K+1)*D(K+2)
         D(K+1) = A(K+1)/DEN
         W(K+1) = (Y(K+1)-C(K+1)*W(K+2))/DEN
  112 CONTINUE
      DEN = B(1)-RT-C(1)*D(2)
      W(1) = 1.
      IF (DEN) 113,114,113
  113 W(1) = (Y(1)-C(1)*W(2))/DEN
  114 DO 115 J=2,M
         W(J) = W(J)-D(J)*W(J-1)
  115 CONTINUE
      IF (NA) 118,118,107
  116 DO 117 J=1,M
         Y(J) = W(J)
  117 CONTINUE
      IBR = 1
      GO TO 107
  118 IF (M1) 119,119,120
  119 IF (M2) 116,116,125
  120 IF (M2) 122,122,121
  121 IF (ABS(BM1(M1))-ABS(BM2(M2))) 125,125,122
  122 IF (IBR) 123,123,124
  123 IF (ABS(BM1(M1)-BD(ID))-ABS(BM1(M1)-RT)) 116,124,124
  124 RT = RT-BM1(M1)
      M1 = M1-1
      GO TO 128
  125 IF (IBR) 126,126,127
  126 IF (ABS(BM2(M2)-BD(ID))-ABS(BM2(M2)-RT)) 116,127,127
  127 RT = RT-BM2(M2)
      M2 = M2-1
  128 DO 129 J=1,M
         Y(J) = Y(J)+RT*W(J)
  129 CONTINUE
      GO TO 107
  130 RETURN
      END
